#include <stdio.h>
#include <stdlib.h>

#include "mmu.h"

#define PAGE_SIZE        512 
#define PHY_MEM_SIZE    1024 /* 1 M/KByte */
#define VIRT_MEM_SIZE 4*1024 /* 4 M/KByte */

int main( int argc, char **argv)
{
  int32_t i;
  mmu *_mmu;

  if ( argc > 1 ) {
    printf("Mode: %s\n", argv[1]);
  }

  fprintf(stdout,"Init mmu\n"); fflush(stdout);
  _mmu = init_mmu(PHY_MEM_SIZE, VIRT_MEM_SIZE, PAGE_SIZE, "./swapfile.swp" );

  fprintf(stdout,"Write data\n"); fflush(stdout);
  for ( i = 0; i < VIRT_MEM_SIZE; i = i + 4 ) {
    store_int32_t(_mmu, i, i);
  }


  fprintf(stdout,"Read data\n"); fflush(stdout);
  int errors = 0;
  for ( i = 0; i < VIRT_MEM_SIZE; i = i + 4 ) {
    if ( get_int32_t(_mmu, i) != i ) {
      printf("Memory error at %d! %d != %d.\n", i, get_int32_t(_mmu, i), i);
      errors++;
    }
  }

  printf("Errors: %d\n",errors);

  free_mmu(_mmu);

  return 0;
}
